| LightHub v4.0.0 Smarthome controller firmware

Functions | Variables
dmx.cpp File Reference
`#include "dmx.h"`
`#include "options.h"`
`#include "item.h"`
`#include "main.h"`

## Functions
int | itemCtrl2 (char *name, int r, int g, int b, int w)
void | DMXImmediateUpdate (short tch, short r, short g, short b, short w)
void | DMXSemiImmediateUpdate (short tch, short trh, int val)
void | DMXput (void)
void | DMXUpdate (void)
void | DMXCheck (void)
void | onDmxFrame (uint16_t universe, uint16_t length, uint8_t sequence, uint8_t *data, IPAddress remoteIP)
void | DMXinSetup (int channels)
void | DMXoutSetup (int channels)
void | DMXOUT_propagate ()
void | artnetSetup ()
void | artnetSetChans (uint8_t minCh, uint8_t maxCh)
void | DmxWriteBuf (uint16_t chan, uint8_t val)

## Variables
uint8_t * | DMXin = NULL
volatile uint32_t | D_State =0
volatile unsigned long | D_checkT =0
aJsonObject * | items
aJsonObject * | dmxArr
volatile uint8_t | timerHandlerBusy
volatile int | DMXinDoublecheck =0
volatile int8_t | propagateBusy = 0

## Function Documentation

## ◆ artnetSetChans()

void artnetSetChans | ( | uint8_t | minCh,
|  | uint8_t | maxCh
| ) |  |

## ◆ artnetSetup()

void artnetSetup | ( |  | ) |

## ◆ DMXCheck()

void DMXCheck | ( | void |  | ) |

## ◆ DMXImmediateUpdate()

void DMXImmediateUpdate | ( | short | tch,
|  | short | r,
|  | short | g,
|  | short | b,
|  | short | w
| ) |  |

## ◆ DMXinSetup()

void DMXinSetup | ( | int | channels | ) |

ToDo: re-init

## ◆ DMXOUT_propagate()

void DMXOUT_propagate | ( |  | ) |

## ◆ DMXoutSetup()

void DMXoutSetup | ( | int | channels | ) |

## ◆ DMXput()

void DMXput | ( | void |  | ) |

## ◆ DMXSemiImmediateUpdate()

void DMXSemiImmediateUpdate | ( | short | tch,
|  | short | trh,
|  | int | val
| ) |  |

## ◆ DMXUpdate()

void DMXUpdate | ( | void |  | ) |

## ◆ DmxWriteBuf()

void DmxWriteBuf | ( | uint16_t | chan,
|  | uint8_t | val
| ) |  |

## ◆ itemCtrl2()

int itemCtrl2 | ( | char * | name,
|  | int | r,
|  | int | g,
|  | int | b,
|  | int | w
| ) |  |

## ◆ onDmxFrame()

void onDmxFrame | ( | uint16_t | universe,
|  | uint16_t | length,
|  | uint8_t | sequence,
|  | uint8_t * | data,
|  | IPAddress | remoteIP
| ) |  |

## Variable Documentation

## ◆ D_checkT

volatile unsigned long D_checkT =0

## ◆ D_State

volatile uint32_t D_State =0

## ◆ dmxArr

aJsonObject* dmxArr
| extern

## ◆ DMXin

uint8_t* DMXin = NULL

## ◆ DMXinDoublecheck

volatile int DMXinDoublecheck =0

## ◆ items

aJsonObject* items
| extern

## ◆ propagateBusy

volatile int8_t propagateBusy = 0

## ◆ timerHandlerBusy

volatile uint8_t timerHandlerBusy
| extern